// Copyright 2015, University of Freiburg,
// Chair of Algorithms and Data Structures.
// Author: Zhiwei Zhang

#include <gtest/gtest.h>
#include "../source/Other/VariableByteEncodingPointer.h"

// _____________________________________________________________________________
TEST(VariableByteEncodingPointerTest, encode) {
  int* list = new int[2];
  char* result1 = new char[1];
  char* result2 = new char[1];
  char* result3 = new char[2];

  list[0] = 1;
  VariableByteEncodingPointer::encode(list, 1, result1);
  ASSERT_EQ("00000001",
            VariableByteEncodingPointer::byteVectorToString(result1, 1));


  list[0] = 150;
  VariableByteEncodingPointer::encode(list, 1, result2);
  // 150 = 22 * 128^0 + 1 * 128^1
  // as vbyte: 10010110 00000001
  ASSERT_EQ("10010110 00000001",
            VariableByteEncodingPointer::byteVectorToString(result2, 2));
  

  list[0] = 1;
  list[1] = 150;
  VariableByteEncodingPointer::encode(list, 2, result3);
  // Gaps 1 and 150 like before
  ASSERT_EQ("00000001 10010110 00000001",
      VariableByteEncodingPointer::byteVectorToString(result3, 3));

  delete[] list;
  delete[] result1;
  delete[] result2;
  delete[] result3;
}

// _____________________________________________________________________________
TEST(VariableByteEncodingPointerTest, encodeDecode) {
  int* plaintext = new int[5];
  char* encoded = new char[20];
  int* decoded = new int[5];

  plaintext[0] = 1;
  plaintext[1] = 5;
  plaintext[2] = 16400;
  plaintext[3] = 20000;
  plaintext[4] = 70000;
  
  VariableByteEncodingPointer::encode(plaintext, 5, encoded);
  VariableByteEncodingPointer::decode(encoded, 5, decoded);
  for (size_t i = 0; i < 5; ++i) {
    ASSERT_EQ(plaintext[i], decoded[i]);
  }

  delete[] plaintext;
  delete[] decoded;
  delete[] encoded;
}
